#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <stdio.h>

#include "fat.h"
#include "mydebug.h"

int main(int argc, char *argv[])
{
  int fdout;
  FAT *fat;
  if(argc < 3)
  {
    fprintf(stderr,"usage:  %s [-v] input output\n",argv[0]);
    return(1);
  }

  if(strcmp("-v",argv[1])==0)
  {
    argv++;
    argc--;
    setenv("DEBUG","1",0);
  }

  INFO_PRINT(("input: %s output: %s\n",argv[1],argv[2]));

  fdout=open(argv[2],O_RDWR|O_CREAT,0666);
  if(fdout < 0)
  {
    perror("Couldn't open");
    return(3);
  }

  fat=FAT_open(argv[1]);
  if(fat == NULL)
  {
    fprintf(stderr,"Invalid FAT filesystem\n");
    return(3);
  }

  FAT_copy(fat,fdout);
  FAT_close(fat);
  close(fdout);

  return(0);
}
