#include <signal.h>
#include <unistd.h>
#include <stdio.h>
#include "spinner.h"

#define SPINNER_DEFAULT "-\\|/"
static const char *spinner_current=SPINNER_DEFAULT;
static unsigned char spinner_pos=0;
static int running=0;

void spin_set(const char *spinner)
{
  if(spinner[0]=='\0') return;

  spinner_current=spinner;
  spinner_pos=0;
}

void spin_set_default(void)
{
  spin_set(SPINNER_DEFAULT);
}

static void spin_draw(int sig)
{
  fprintf(stderr,"\b%c",spinner_current[spinner_pos++]);

  if(spinner_current[spinner_pos]=='\0')
    spinner_pos=0;  
}

void spin_stop(void)
{
  if(running != 0)
  {
    ualarm(0,0);
    running=0;
    fprintf(stderr,"\b");
  }
}

void spin_start(void)
{
  if(running == 0)
  {
    signal(SIGALRM,spin_draw);
    fprintf(stderr," ");
//    spin_draw(0);
    running=100000;
    ualarm(100000,100000);
  }
}
